# GALLIENNE.B programme de calcul du rythme cardiaque avec capteur 101020033 et led
# le programme ci-dessous renvoi la valeur du rythme cardiaque et fait clignoter une led au même rythme
from microbit import *
import time
from machine import time_pulse_us

t = 0	#
temps_dep = 0	# Déclaration et initialisation des variables
tps = 0


def mesure() :
    #temps_dep = running_time()#on place le temps courant ds la variable temps_dep
    pin0.read_digital() #acquisition du signal sur la broche "0" c.a.d pin0
    pin2.write_analog(1023) #allumage led le temps de t1 c.a.d le temps ou pin0 est à 1
    t1 = (time_pulse_us(pin0,1))
    """la fonction time_pulse_us(pin0, 1) qui attend que la broche pin0(premier paramètre) soit au niveau 1
    (second paramètre) et qui renvoie la durée en us pendant laquelle cette broche reste au niveau 1. Il faut pour que la broche pin0
    soit préalablement configurée en entrée d'où la ligne précédente : pin0.read_digital()"""
    pin2.write_analog(0) #eteindre led le temps de t2 c.a.d le temps ou pin0 est à 0
    t2 = (time_pulse_us(pin0,0))
    T = (t1 + t2)/1000000 #calcul de la période en seconde
    rythme = int(60/T) # calcul de la pulsation cardiaque bpm/min
    return rythme #on renvoie la valeur de la pulsation dans la boucle infinie "while True"

while True :   #boucle infine
    if button_a.is_pressed(): #boucle conditionnelle si bouton A est pressé
        t = mesure() # on active la fontion "mesure" et on stocke le résultat dans "t"
        print ("frequence_cardiaque=", t, "pulsation/min") # affichage de la pulsation
        sleep(10) # temporisation de 10ms

