# GALLIENNE.B programme de calcul du rythme cardiaque avec capteur 101020033 et la carte MicrobitV2
# le programme ci-dessous renvoi la valeur du rythme cardiaque et fait clignoter un coeur sur la matrice led au même rythme
from microbit import * #importation des bibliothèques Microbit
import time # importation de la bibliothèque de temps
from machine import time_pulse_us # importation de la bibliothèque de temps courant

t1 = 0	        #
t2 = 0	        # Déclaration et initialisation des variables
T = 0           #
t=0             #

""" fonction "def mesure()". Une fonction est un sous-programme qui regroupe plusieurs instructions.
Une fonction peut recevoir des données en entrée (appelées paramètres ) et/ou renvoyer des données en sortie.
On lui donne un nom qui servira à l’utiliser à chaque fois qu’on le souhaite."""
def mesure() :
    pin0.read_digital() #acquisition du signal sur la broche "0" c.a.d pin0
    t1 = (time_pulse_us(pin0,1))
    display.show(Image.HEART)
    """la fonction time_pulse_us(pin0, 1) qui attend que la broche pin0(premier paramètre) soit au niveau 1
    (second paramètre) et qui renvoie la durée en us (microseconde) pendant laquelle cette broche reste au niveau 1.
    Il faut pour que la broche pin0 soit préalablement configurée en entrée
    d'où la ligne précédente : pin0.read_digital()"""
    display.clear() #extinction de la matrice led le temps de t2 c.a.d le temps ou pin0 est à 0
    t2 = (time_pulse_us(pin0,0))
    T = (t1 + t2)/1000000 #calcul de la période en seconde
    rythme = int(60/T) # calcul de la pulsation cardiaque bpm/min (int() pour afficher un entier)
    return rythme #on renvoie la valeur de la pulsation dans la boucle infinie "while True"

while True :   #boucle infine
    if button_a.is_pressed(): #boucle conditionnelle si bouton A est pressé
        t = mesure() # on active la fontion "mesure" et on stocke le résultat dans "t" c.a.d la valeur de "rythme"
        print ("frequence_cardiaque=", t, "pulsation/min") # affichage de la pulsation
        sleep(10) # temporisation de 10ms
